<template>
  <b-container fluid id="board">
    <div id="chart" class="ml-md-auto">
      <b-row>
        <div class="title" style="margin-left: 40%">Worktimes Month</div>
      </b-row>
      <b-row class="text-center">
        <b-col>
          <apexchart
            width="500"
            type="bar"
            breakpoint: undefined
            passive
            :current-page="currentPage"
            :options="options"
            :per-page="perPage"
            :series="series"
          >
          </apexchart>
        </b-col>
      </b-row>
    </div>
  </b-container>
</template>

<script>
import Vue from "vue";
import VueApexCharts from "vue-apexcharts";
import moment from "moment";
import EventBus from "@/components/EventBus";
import config from "@/Utils/config.json";
import { getUserId } from "@/router/auth.js";
import { LayoutPlugin } from "bootstrap-vue";
import Axios from "axios";
Vue.use(LayoutPlugin);

Vue.component("apexchart", VueApexCharts);
export default {
  name: "ChartTimeWeek",
  data() {
    return {
      currentPage: 1,
      perPage: 1,
      pageOptions: [1, 10, 15],
      timevalues: [],
      options: {
        chart: {
          id: "vuechart-example",
        },
        xaxis: {
          categories: [],
        },
        stroke: {
          curve: "smooth",
        },
        markers: {
          strike: 1,
        },
        dataLabels: {
          enabled: true,
          formatter: function (val) {
            var pad = function (num, size) {
                return ("000" + num).slice(size * -1);
              },
              time = parseFloat(val).toFixed(3),
              hours = Math.floor(time / 60 / 60),
              minutes = Math.floor(time / 60) % 60,
              seconds = Math.floor(time - minutes * 60);

            return (
              pad(hours, 2) + ":" + pad(minutes, 2) + ":" + pad(seconds, 2)
            );
          },
          offsetY: -20,
          style: {
            fontSize: "12px",
            colors: ["#304758"],
          },
        },
      },
      series: [
        {
          name: "series-1",
          data: [],
        },
      ],
    };
  },
  methods: {
    getData(isCategories = false) {
      var times = this.timevalues;

      var categoriesValue = [];
      var categories = [];
      var month = [
        "January",
        "February",
        "March",
        "April",
        "May",
        "June",
        "July",
        "August",
        "September",
        "October",
        "November",
        "December",
      ];
      times.forEach((element) => {
        var currentDay = element.month;
        var currentYear = element.year;
        if (!categoriesValue[currentDay + "/" + currentYear]) {
          categories.push(month[currentDay] + " " + currentYear);
          categoriesValue[currentDay + "/" + currentYear] = 0;
          categoriesValue[currentDay + "/" + currentYear] += element.timeDuration;
        } else {
          categoriesValue[currentDay + "/" + currentYear] += element.timeDuration;
        }
      });

      var values = [];
      Object.keys(categoriesValue).forEach((element) => {
        values.push(categoriesValue[element]);
      });
      return isCategories ? categories : values;
    },
    transfornData(data) {
      var tmp = data;
      var arrayTime = [];
      for (let index = 0; index < tmp.length; index++) {
        var startDate = new Date(tmp[index].start);
        var endDate = new Date(tmp[index].end);
        var date = new Date(tmp[index].end);
        var dateWork = moment(date).format("DD/MM/YYYY");
        var tmpTime = (endDate.getTime() - startDate.getTime()) / 1000;
        arrayTime.push({
          timeDuration: tmpTime,
          month: endDate.getMonth(),
          year: endDate.getUTCFullYear(),
          id: tmp[index].id,
          user_id: tmp[index].user_id,
          dateWork: dateWork,
        });
      }
      return arrayTime;
    },
    getDay() {
      Axios.get(
        `${config.config.res_endpoint}api/workingtimes/${getUserId()}`,
        {
          headers: {
            Authorization: "Bearer " + localStorage.getItem("accesToken"),
          },
        }
      ).then((response) => {
        this.timevalues = this.transfornData(response.data.data);
        this.updateChart();
      });
    },
    updateChart() {
      this.options = {
        ...this.options,
        ...{
          xaxis: {
            type: "category",
            categories: this.getData(true),
          },
        },
      };

      this.series = [
        {
          name: "time",
          data: this.getData(),
        },
      ];
    },
  },
  mounted() {
    Axios.get(`${config.config.res_endpoint}api/workingtimes/${getUserId()}`, {
      headers: {
        Authorization: "Bearer " + localStorage.getItem("accesToken"),
      },
    }).then((response) => {
      this.timevalues = this.transfornData(response.data.data);
      this.updateChart();
    });

    EventBus.$on("ADD_WORKS", () => {
      this.getDay();
    });
  },
};
</script>

<style>
#board {
  display: flex;
  flex-direction: row;
  justify-content: space-between;
}
</style>